<?php

class Custom_EmailQueue_Block_Adminhtml_Email_Container_Grid extends Mage_Adminhtml_Block_Widget_Grid
{
    public function __construct()
    {
        parent::__construct();
        $this->setId('custom_emailqueue_grid');
        $this->setDefaultSort('message_id');
        $this->setDefaultDir('DESC');
        $this->setSaveParametersInSession(true);
        $this->setUseAjax(true);
    }

    protected function _prepareCollection()
    {
        $collection = Mage::getModel('core/email_queue')->getCollection()
            ->addOnlyForSendingFilter()
            ->setPageSize(1)
            ->setCurPage(1)
            ->join(array('a' => 'core/email_recipients'), 'main_table.message_id = a.message_id', array(
                'recipient_email'   => 'recipient_email',
                'recipient_name'    => 'recipient_name'
            ))
            ->addFilterToMap('message_id', 'main_table.message_id');;

        $this->setCollection($collection);
        parent::_prepareCollection();

        return $this;
    }

    protected function _prepareColumns()
    {
        $helper = Mage::helper('custom_emailqueue');

        $this->addExportType('*/*/exportEmailQueueCsv', $helper->__('CSV'));
        $this->addExportType('*/*/exportEmailQueueExcel', $helper->__('Excel XML'));

        $this->addColumn('message_id', array(
            'header' => $helper->__('Email #'),
            'index'  => 'message_id',
            'filter_index' => 'main_table.message_id',
        ));

        $this->addColumn('created_at', array(
            'header' => $helper->__('Creado'),
            'type'   => 'datetime',
            'index'  => 'created_at'
        ));

        $this->addColumn('processed_at', array(
            'header' => $helper->__('Procesado'),
            'type'   => 'datetime',
            'index'  => 'processed_at'
        ));

        $this->addColumn('entity_type', array(
            'header' => $helper->__('Tipo'),
            'type'   => 'text',
            'index'  => 'entity_type'
        ));

        $this->addColumn('event_type', array(
            'header' => $helper->__('Evento'),
            'type'   => 'text',
            'index'  => 'event_type'
        ));

        $this->addColumn('recipient_email', array(
            'header' => $helper->__('Email'),
            'type'   => 'text',
            'index'  => 'recipient_email'
        ));

        $this->addColumn('recipient_name', array(
            'header' => $helper->__('Nombre'),
            'type'   => 'text',
            'index'  => 'recipient_name'
        ));

        return parent::_prepareColumns();
    }

    public function getGridUrl()
    {
        return $this->getUrl('*/*/grid', array('_current'=>true));
    }
}